/*
    tstore - an archive format for archiving tar archives
    Copyright (C) 2004  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "tstore.h"

uint64_t hash_size;
uint64_t buckets;

void init_hash()
{
  if (buckets==0) buckets=1;
  hash_size=prevprime(buckets<<16);
}

uint64_t hash_sector(uint8_t *data)
{
  uint64_t r=0;
  int i;
  for (i=0;i<512;++i)
    r=((r<<8)+data[i])%hash_size;
  return r;
}

void hash_advice(int maxused)
{
  if (maxused>18) {
    printf("Largest hash-bucket %d of 73 slots used\n",maxused);
    if (maxused>54)
      printf("Rehashing suggested\n");
  }
}
